PSST(1)

NAME
psst - Power Stress and Shaping Tool

SYNOPSIS
psst [options <value>]

DESCRIPTION
The Power Stress and Shaping Tool (PSST) is a controlled power 'virus' for Intel SoC components such as CPU and GPU.
The objective is to subject the SoC at different run-time-varying utilization levels for analysis. This is done by controlled duty-cycling of utilization to specific contour. A simplest contour could be fixed low utilization. This allows simple usage, such as logging of system parameters at fixed low overhead even at small polling intervals (ms). More complex usage, such as study of governors, workloads e.t.c., are possible by applying different power shape contours and options.

OPTIONS

-C --cpumask CPUMASK
    CPUMASK is hexadecimal bit mask of cpu selected. (e.g., a1 selects cpu 0, 5, 7. default: every online cpu, maximum 1024)

-p --poll-period pollperiod
    pollperiod specifies period for logging in milliseconds (default 500 ms)

-d --duration m
    specifies duration m in milliseconds to run psst (default is 3600000; 1 hour)

-l --log-file path
    specifies the full path to the logfile (default is /var/log/psst.csv)

-v --verbose
    enables verbose mode (default: disabled when args specified)

-V --version
    prints version

-T --track-max-cpu
    Track the cpu# with maxed freq during poll period

-h --help
    prints help

-s --shape-func shape-func,arg
    Specifies power shape function and argument:
    Shape Function | Argument
    single-step,v | where v is load step height [C0%]. (default shape: single-step,0.1)
    sinosoid,w,a | where w is wavelength [seconds] and a is the amplitude (max load %)
    stair-case,v,u | where v is load step height [C0%], u is step length (sec)
    single-pulse,v,u | where v is load step height [C0%], u is step length (sec)
    linear-ramp,m | where m is the slope (load/sec)
    saw-tooth,m,a | slope m (load/sec); reversed after max a% or min(0.1)%

EXAMPLES

1.  Use psst just for logging various power/thermal parameters:
    sudo psst     # same as $./psst -s single-step,0.1 -p 500 -v

2.  Linear ramp CPU power with slope 3% usage-per-sec applied for cpu 1 and 3, polling and reporting every 700mS, output on termial, running for 33 seconds:
    sudo psst -s linear-ramp,3 -C a -p 700 -d 33000 -v

AUTHOR
Started by Noor Mubeen

COPYRIGHT
Copyright © 2017, Intel Corporation License GPLv2: GNU GPL version 2
This is free software: you are free to change and redistribute it. There is NO WARRANTY, to the extent permitted by law. Or, say, there is NO warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.